
import java.awt.*;
import java.lang.*;
import java.applet.*;

class SourceCode{
public static final int MAX=14;
                    int aktiivinen=0,
                        startline=0,//tekstirivi
                        sarake=0;
                    boolean update_output_flag;
                    boolean reset_output_flag;

        Font f=new Font ("Courier",Font.PLAIN,12);

        String[] ohjelma={
               /*0*/ "/*Clogal vs Local*/",
              /*1*/  "#include<stdio.h>",
              /*2*/  " ",
              /*3*/  " int variable=10;",
              /*4*/  " ",
              /*5*/  "void use_global(void){",
              /*6*/  "  printf(\"Global varible is %d \\n\",variable);",
	      /*7*/  "  variable=7;",
	      /*8*/  "  }",
              /*9*/  "void use_local(void){",
	      /*10*/ "  int variable;",
	      /*11*/ "  variable=5;",
              /*12*/ "  printf(\"Local varible is %d \\n\",variable);",
              /*13*/ "  }",
              /*14*/ " ",
              /*15*/ "void main(void){",
              /*16*/ " ",
              /*17*/ "  printf(\"Global varible is %d \\n\",variable);",
              /*18*/ "  use_global();",
              /*19*/ "  printf(\"Global varible is %d \\n\",variable);",
              /*20*/ "  use_local();",
              /*21*/ "  printf(\"Global varible is %d \\n\",variable);",
              /*22*/ " }",
                     "END"};

        //ohjelman tulosteet
        String outtext[]={"NOTHING TO SHOW",
                       "Global varible is 10",
                       "Global varible is 10",
                       "Global varible is 7",
                       "Local  varible is 5",
                       "Global varible is 7"};

        //jrjestys miss ajetaan
        int order[]={15,17,18,5,6,7,8,19,20,9,11,12,13,21,22};

public SourceCode(int par_sarake, int par_rivi)
       {
        sarake=par_sarake;
        startline=par_rivi;
       }
public void step()//ajetaan pykl eteenpin
       {
         aktiivinen++;
         reset_output_flag=false;

         if(aktiivinen>MAX)
         {
           aktiivinen=0;
           reset_output_flag=true;
         }

       }

public void show(Graphics g)//nytetn ruudulla
  {
       int i,
           rivi=startline;
       g.setFont(f);
       for(i=0;!ohjelma[i].equals("END");i++,rivi+=12)
        {
         if(i!=order[aktiivinen])
          {
            g.setColor(Color.black);
          }
          else
          { //jos ajettava rivi kirjoitetaan punaisella
            //Mustaan laatikkoon
            g.fillRect(sarake, rivi-12,ohjelma[i].length()*6,14);
            g.setColor(Color.red);
          }

          g.drawString(ohjelma[i],sarake,rivi);

         }
  }
public String output() // mit palautetaan
       {
        int right_text=0;
        switch (aktiivinen)
         {
          case 2:
           right_text=1;
          break;

          case 5:
           right_text=2;
          break;

          case 8:
           right_text=3;
          break;

          case 12:
           right_text=4;
          break;

          case 14:
           right_text=5;
          break;

          default:
            right_text=0;
          break;
         }
          return outtext[right_text]+"\n";

       }

private void update_flags()
        {
        switch (aktiivinen)
         {
          case 0:
          update_output_flag=false;
          reset_output_flag=true;
          break;
          case 2:
          case 5:
          case 8:
          case 12:
          case 14:
               update_output_flag=true;
               reset_output_flag=false;
          break;

          default:
            update_output_flag=false;
            reset_output_flag=false;
          break;
         }

        }
public boolean update_output()
       {
        update_flags();
        return update_output_flag;
       }

public boolean reset_output()
       {
        update_flags();
        return reset_output_flag;
       }
}



public class Apletti extends Applet implements Runnable
 {
   SourceCode Source =new SourceCode(10,300);
   TextArea OutScreen ;
   Thread th;
   int animation_speed_delay=1000;

public Apletti()
       {

       }
public void init()
          {
            resize(500,500);
            add ("Step",new Button ("Step"));
            add ("Animoi",new Button ("Animoi"));
            add ("Pysyt",new Button ("Pysyt"));
            add ("-",new Button ("-"));
            add ("+",new Button ("+"));
            add (OutScreen = new TextArea());
            OutScreen.setBackground(Color.black);
            OutScreen.setForeground(Color.white);
            OutScreen.setEditable(false);

          }

  public void run()
        {
          Image piilopinta = createImage(500,500);
		Graphics piilog = piilopinta.getGraphics();
		Graphics appletg = getGraphics();
		piilog.setColor(getBackground());
		piilog.fillRect(0,0,500,500); // tyhjennetn piilopinta
		piilog.setColor(appletg.getColor());

		while (true)
		{
                        piilog.setColor(getBackground());
                        piilog.fillRect(0,0,500,500);
                        Source.step();
                        Source.show(piilog);
                        if(Source.reset_output())
                        {

                         OutScreen.replaceRange("",0,OutScreen.getCaretPosition());

                         }
                         if(Source.update_output())
                         {
                          OutScreen.append(Source.output());
                         }


			appletg.drawImage(piilopinta,0,0,this);
			try
			{
				th.sleep(animation_speed_delay);
			}
			catch(InterruptedException e) {}


		}
        }

public void paint(Graphics g)
       {

            Source.show(g);

            if(Source.reset_output())
            {

              OutScreen.replaceRange("",0,OutScreen.getCaretPosition());

            }
            if(Source.update_output())
             {
               OutScreen.append(Source.output());
             }
       }

public boolean action(Event evt,Object arg)
   {
        if (evt.target instanceof Button)
         {
            if ("Step".equals(arg))
             {
               if (th==null)
                {
                   Source.step();
                   repaint();
                }
             }

            else if ("Animoi".equals(arg))
            {
               if (th==null)
                {
                  th = new Thread(this);
                  th.start();
                }
            }
            else if ("Pysyt".equals(arg))
            {
              if (th!=null)
              {
                 th.stop();
                 th=null;
              }
            }

            else if ("+".equals(arg))
            {
              if (th!=null)
              {
                 if(animation_speed_delay>=0)
                 {
                  animation_speed_delay-=100;
                 }
                else
                 {
                  animation_speed_delay=100;
                 }
             }

            }

            else if ("-".equals(arg))
            {
              if (th!=null)
              {
                  animation_speed_delay+=100;
              }
            }
         }
    return true;
   }
 }
