import java.awt.*;
import java.applet.*;


class Kuvio
{
	protected int x;
	protected int y;

	public Kuvio(int x, int y)
	{
		this.x=x;
		this.y=y;
	}

	public void uusiSijainti(int x, int y)
	{
		this.x=x;
		this.y=y;
	}

	public void Siirra(int dx, int dy)
	{
		this.x+=dx;
		this.y+=dy;
	}

}

class Ympyra extends Kuvio
{
	private int sade;

	public Ympyra(int x, int y, int sade)
	{
		super(x,y);
		this.sade=sade;
	}
                public void nayta (Graphics g)
	{
	
		g.drawOval(x, y, sade, sade);
	
	}

	
	public int get_x()
	{
	return x;
 	}
}
class Arvo extends Kuvio
{
	private String arvo;

	public Arvo(String arvo,int x, int y)
	{
		super(x,y);
                this.arvo=arvo;  
	}
	public void set_arvo(String arvo)
	{
		this.arvo = arvo;
	}
	public void uusi_arvo()
	{
	                int x;
	                x=Integer.valueOf(this.arvo).intValue();
	                x++;
	                Integer i=new Integer (x);
	                this.arvo=i.toString();
	                
	}
	public void nayta (Graphics g)
	{
		
		g.drawString(arvo,x,y);
		
	}

}	
public class Ympyra5 extends Applet implements Runnable
{
	CheckboxGroup Piirtolajit = new CheckboxGroup();
	Ympyra ymp = new Ympyra(220,280,50);
	Arvo arv = new Arvo("1",240,310);
	Label kysy_arvo;
	TextField arvo_str;
	boolean nakyva = false;
	
	Thread animaatio;
	boolean lopetus=false;

	Image piilopinta; 
	
	public void init() // Kutsutaan autom. heti appletin kynnistmisen jlkeen
	{
		resize(600,400);
		piilopinta = createImage(600,400);
		add (kysy_arvo = new Label ("Anna kokonaisluku"));
		add (arvo_str = new TextField(3));
		add ("Animoi", new Button("Animoi"));
	
	}

	public void start () // Kutsutaan autom. init()-funktion jlkeen
	{
		
	}

	public void stop ()
	{
		if (animaatio!=null)
		{
			animaatio.stop();
			animaatio=null;
		}
	}
		
	public void paint (Graphics g) // piirtopinta kuntoon, vrintn
	{
		// Kuva piirretn ensin piilopinnalle (=itse mritelty kuva).
		// Piilopinta piirretn kokonaisuutena piirtopinnalle.
	
		Graphics piilog = piilopinta.getGraphics();
		Graphics appletg = getGraphics();
		
		piilog.setColor(getBackground());
		piilog.fillRect(0,0,600,400); // tyhjennetn piilopinta
		piilog.setColor(appletg.getColor());
		
		tulostaTekstit(piilog);
		ymp.nayta(piilog);		
	
		arv.nayta(piilog);	
		appletg.drawImage(piilopinta,0,0,this);					
	}

	public void update (Graphics g)  // repaint() kutsuu tt
	{				
		// Jrjestelmn alkuperisen update()-funktion kyttminen
		// aiheuttaisi animaatiossa vrin, koska update() tyhjent piirtopinnan.
		// Tmn vuoksi funktio on kirjoitettu itse 
	
		paint(g);
	}		

	public void run()    // animaatio-sikeen koodi 		
	{		     // kynnistyy kun sie kynnistetn funktiolla animaatio.start()
			     // lopetetaan kun sie lopetetaan funktiolla animaatio.stop()

		// Suoritetaan animaatio-siett "ikuisessa silmukassa"
		// Kuvan paikkaa siirretn jokaisella kierroksella ja kuva nytetn
		// Kuhunkin kierrokseen liittyy odotusjakso (sleep(100)) 
		// odotusjakson aikana muu appletin toiminta on mahdollista

		boolean vaihe1=true;
		boolean vaihe2=false;
		boolean vaihe3=false;		

		while (!lopetus)
		{
			repaint();
			try
			{
				animaatio.sleep(20);
			}
			catch(InterruptedException e) {}
			if(ymp.get_x()<400 && vaihe1)
			{
			ymp.Siirra(1,0);
			arv.Siirra(1,0);
			}
			if (ymp.get_x()==400 && vaihe1)
			{
				vaihe1=false;
				vaihe2=true;
			}
			if (vaihe2)
			{
			                try
			                {
			                            animaatio.sleep(1000);
			                            arv.uusi_arvo();
			                            vaihe2=false;
			                            vaihe3=true;
			                }
			                catch(InterruptedException e) {}
                        }

			if(ymp.get_x()>120 && vaihe3)
			{
			ymp.Siirra(-1,0);
			arv.Siirra(-1,0);
			}
		        
	
			
		}
	}
	


/*	public boolean imageUpdate(Image i, int info, int x, int y, int widh, int height)
	{
		return true;   //voidaan tarvita, jos kuvia ilmestyy liian aikaisin 
	}
*/	

	// TAPAHTUMAT ////////////////////////////////////////////////////////////////

	public boolean action (Event evt, Object arg)
	{
		
		if (evt.target instanceof Button)
		{
		
			if("Animoi".equals(arg))
			{
			         arv.set_arvo(arvo_str.getText());
			         if(animaatio==null)
				 {
				     animaatio=new Thread(this);
				     animaatio.start();
				 }                 
				                 
		                	
			
	                }
	        }
	        return true;
	                   
	}
		

	public void tulostaTekstit(Graphics g)
	{
		/*Font fontti = new Font ("Arial",Font.PLAIN,8);
		g.drawString("void main(void)",10,100);
		g.drawString("{",10,112);
		g.drawString("}",10,148);*/
		g.drawRect(100,100,200,250);
		g.drawRect(350,100,200,250);
		g.drawRect(100,250,100,100);
		g.drawRect(200,250,100,100);
		g.drawRect(350,250,200,100);
		g.drawString("paluuarvo",120,270);
		g.drawString("parametri",220,270);
		g.drawString("void main void",105,110);
		g.drawString("{",105,125);
		g.drawString("int luku1,luku2;",115,140);
		g.drawString("printf(Anna kokonaisluku:);",115,155);
		g.drawString("scanf('%d',&luku1);",115,170);
		g.drawString("luku2=funktio(luku1);",115,185);
		g.drawString("printf('Luku2 on %d',luku2);",115,200);
		g.drawString("}",105,215);
		g.drawString("int funktio(int luku1)",355,110);
		g.drawString("{",355,125);
		g.drawString("int uusi;",365,140);
		g.drawString("uusi=luku1+1;",365,155);
		g.drawString("return uusi;",365,170);
		g.drawString("}",355,185);

		}
				
/*	public boolean mouseDown(Event e, int x, int y)
	{
		Graphics g = getGraphics();
		ymp.uusiSijainti(x,y);
		ymp.nayta(g);
		return true;
	}*/
}/* Kimmo Hirvel */

