#include <stdio.h>
#include <stdlib.h>

#define NumElems(x) (sizeof(x)/sizeof(x[0]))

enum Funkiot {Aja, Tulosta, Lopeta};

int aja();
int tulosta();
int lopeta();

const struct {
  int (*funktio) ();
  const char *nimi;
} funktiot[] = {
  { aja, "1-Aja" },
  { tulosta, "2-Tulosta" },
  { lopeta, "3-Lopeta" }
};

int main()
{
  int valinta = Tulosta;

  while (valinta != Lopeta) {
    valinta = Tulosta;
    funktiot[valinta].funktio(); /* tulostetaan vaihtoehdot */
    valinta = getchar() - '1'; /* luetaan valinta */
    
    /* tarkistetaan onko valinta ok ja ajetaan jos on */
    if (valinta >= 0 && valinta < NumElems(funktiot))
      funktiot[valinta].funktio();
  }

  return 0;
}

int aja()
{
  printf("\nAjetaan...\n");
  return 1;
}

int tulosta()
{
  int i;

  printf("\nValinnat: \n");

  for (i = 0; i < NumElems(funktiot); i++)
    printf("%s\n", funktiot[i].nimi);

  return i;
}

 int lopeta()
{
  return 1;
}
