import java.awt.*;
import java.applet.*;

class Kuvio
{
	protected int x;
	protected int y;
	public Kuvio(int x, int y)
	{
		this.x=x;
		this.y=y;
	}
	public void uusiSijainti(int x, int y)
	{
		this.x=x;
		this.y=y;
	}
	public void Siirra(int dx, int dy)
	{
		this.x+=dx;
		this.y+=dy;
	}
}

class Ympyra extends Kuvio
{
	private int sade;
	public Ympyra(int x, int y, int sade)
	{
		super(x,y);
		this.sade=sade;
	}
                public void nayta (Graphics g)
	{
		g.drawOval(x, y, sade, sade);
	}
	        public void asetaXY (int x, int y)
	{
		this.x=x;
		this.y=y;
	}
	public int get_x()
	{
	return x;
 	}
}

class Arvo extends Kuvio
{
	private String arvo;
	public Arvo(String arvo,int x, int y)
	{
		super(x,y);
                this.arvo=arvo;  
	}

        public void asetaXY (int x, int y)
	{
		this.x=x;
		this.y=y;
	}

	public void set_arvo(String arvo)
	{
		this.arvo = arvo;
	}
	public void uusi_arvo()
	{
	                int x;
	                x=Integer.valueOf(this.arvo).intValue();
	                x++;
	                Integer i=new Integer (x);
	                this.arvo=i.toString();
        }

	public int get_x()
	{
	return x;
 	}

	public void nayta (Graphics g)
	{
		g.drawString(arvo,x,y);
	}
}	

public class Ympyra5 extends Applet implements Runnable
{
	CheckboxGroup Piirtolajit = new CheckboxGroup();
	Ympyra ymp = new Ympyra(220,280,50);
	Ympyra ymp_p = new Ympyra(220,280,50);
	Arvo arv = new Arvo("---",240,310);
	Arvo arv_p = new Arvo("---",240,310);
	Label kysy_arvo;
	TextField arvo_str;
	boolean nakyva = false;
	Thread animaatio;
	boolean lopetus=false;
	Image piilopinta; 

	int rivinro=1;	//mill rivill ollaan animaatio-ohjelmassa -> punanen teksti
	int i;		//int-apumuuttuja
	boolean vaihe1=false;
	boolean vaihe2=false;
	boolean vaihe3=false;	

	public void init() // Kutsutaan autom. heti appletin kynnistmisen jlkeen
	{
		resize(600,400);
		piilopinta = createImage(600,400);
		add ("rivi", new Button("Seuraava rivi"));
		add ("Alusta", new Button("Aloita alusta"));
		
}
	public void start () // Kutsutaan autom. init()-funktion jlkeen
	{
	}
	
	public void stop ()
	{
		if (animaatio!=null)
		{
			animaatio.stop();
			animaatio=null;
		}
	}

	public void paint (Graphics g) // piirtopinta kuntoon, vrintn
	{
		// Kuva piirretn ensin piilopinnalle (=itse mritelty kuva).
		// Piilopinta piirretn kokonaisuutena piirtopinnalle.
		Graphics piilog = piilopinta.getGraphics();
		Graphics appletg = getGraphics();
		piilog.setColor(getBackground());
		piilog.fillRect(0,0,600,400); // tyhjennetn piilopinta
		piilog.setColor(appletg.getColor());
		tulostaTekstit(piilog);
		ymp.nayta(piilog);
		arv.nayta(piilog);	
		ymp_p.nayta(piilog);
		arv_p.nayta(piilog);	
		appletg.drawImage(piilopinta,0,0,this);
	}

	public void update (Graphics g)  // repaint() kutsuu tt
	{				
		// Jrjestelmn alkuperisen update()-funktion kyttminen
		// aiheuttaisi animaatiossa vrin, koska update() tyhjent piirtopinnan.
		// Tmn vuoksi funktio on kirjoitettu itse 
		paint(g);
	}		

	public void run()    // animaatio-sikeen koodi 		
	{		     // kynnistyy kun sie kynnistetn funktiolla animaatio.start()
			     // lopetetaan kun sie lopetetaan funktiolla animaatio.stop()
		// Suoritetaan animaatio-siett "ikuisessa silmukassa"
		// Kuvan paikkaa siirretn jokaisella kierroksella ja kuva nytetn
		// Kuhunkin kierrokseen liittyy odotusjakso (sleep(100)) 
		// odotusjakson aikana muu appletin toiminta on mahdollista
		
			
		
		while (!lopetus)
		{
			repaint();
	
			if(vaihe1)
			{
				
				
				try
				{
					animaatio.sleep(0);
				}
				catch(InterruptedException e) {}
				if(arv.get_x()<400 )
				{
					//ymp.Siirra(2,0);
					arv.Siirra(2,0);
				}
				else
				{
					vaihe1=false;
					//rivinro++;
					stop();
				}
			}
			
		}
	}
	
/*	public boolean imageUpdate(Image i, int info, int x, int y, int widh, int height)
	{
		return true;   //voidaan tarvita, jos kuvia ilmestyy liian aikaisin 
	}
*/	
	// TAPAHTUMAT ////////////////////////////////////////////////////////////////
	
	public boolean action (Event evt, Object arg)
	{
		
		if (evt.target instanceof Button)
		{
		
       			if("Aloita alusta".equals(arg))
			{
				rivinro=1;
				arv.set_arvo("---");
				arv_p.set_arvo("---");
				ymp.asetaXY(220,280);
				ymp_p.asetaXY(220,280);
				arv.asetaXY(240,310);
				arv_p.asetaXY(240,310);
				stop();
				vaihe1=false;
				repaint();
			}
	       		if("Seuraava rivi".equals(arg))
			{

				if(rivinro<14 && vaihe1==false)rivinro++;   

				if(rivinro==4)
				{
					arv.set_arvo("5");
					arv_p.set_arvo("5");
					repaint();
				}

				if(rivinro==6 && vaihe1==false)
				{
					vaihe1=true;
					arv.asetaXY(220,270);
					arv.set_arvo("Luku1:n osoite");
					animaatio=new Thread(this);
					animaatio.start();
				}
				if(rivinro==10)arv_p.set_arvo("6");
				
/*				if(rivinro==10 && vaihe3==false)
				{
					vaihe3=true;
					animaatio=new Thread(this);
					animaatio.start();
				}*/
				repaint();              
			
			}
	        }
	        return true;
	                   
	}
		
	public void tulostaTekstit(Graphics g)
	{
		/*Font fontti = new Font ("Arial",Font.PLAIN,8);

		g.drawString("void main(void)",10,100); 
		g.drawString("{",10,112);
		g.drawString("}",10,148);*/

		//g.drawString("rivinro" +rivinro,10,10);

		g.drawRect(100,100,200,250); 
		g.drawRect(350,100,200,250); 
		g.drawRect(100,250,100,100); 
		g.drawRect(200,250,100,100); 
		g.drawRect(350,250,200,100); 
		//g.drawString("&luku1:n arvo",120,270); 
		g.drawString("Luku1:n osoite",220,270); 
	
		if(rivinro>=5)
		g.drawString("Luku ennen: 5",105,270); 
	
		if(rivinro>=9)
		g.drawString("Kasvatan yhdell...",105,285); 

		if(rivinro>=12)
		g.drawString("Luku jlkeen: 6",105,300); 

		//g.setColor(Color.red); break;

for(i=1;i<=15;i++)
{	

if(i==rivinro)g.setColor(Color.red);else g.setColor(Color.black);

switch (i)
	{
	case 1:	g.drawString("void main void",105,110); 
		break;
	case 2:	g.drawString("{",105,125); 
		break;
	case 3:	g.drawString("int luku1;",115,140); 
		break;
	case 4:	g.drawString("luku1=5;",115,155); 
		break;
	case 5:	g.drawString("printf(''Luku ennen: %d'',luku);",115,170); 
		break;
	case 6:	g.drawString("funktio(&luku1);",115,185); 
		break;
	case 12:g.drawLine(145,190,147,200);
		g.drawString("printf('' nLuku jlkeen: %d'',luku);",115,200); 
		break;
	case 13:g.drawString("}",105,215); 
		break;
	case 7:	g.drawString("void funktio(int *luku)",355,110); 
		break;
	case 8:g.drawString("{",355,125); 
		break;
	case 9: g.drawLine(399,130,401,140);
		g.drawString("printf('' nKasvatan yhdell...''",369,140); 
		break;
	case 10:g.drawString("(*luku)++;",369,155); 
		break;
	case 18:g.drawString("",365,170); 
		break;
	case 11:g.drawString("}",355,185); 
		break;
	}

	}
}
		
}
